commit ddf7f43293dbbf14e2bfa1479c51bf60c3d0a383
Author: Denis Barbier <bouzim@gmail.com>
Date:   Thu Dec 22 10:32:17 2011 +0100

    Bugfix: else clause applies to the wrong if statement because of missing braces

diff --git a/src/AIS/AIS_InteractiveContext.cxx b/src/AIS/AIS_InteractiveContext.cxx
index c55a02a..2209b76 100644
--- a/src/AIS/AIS_InteractiveContext.cxx
+++ b/src/AIS/AIS_InteractiveContext.cxx
@@ -2764,10 +2764,10 @@ void AIS_InteractiveContext::ClearGlobal(const Handle(AIS_InteractiveObject)& an
       myAISDetectedSeq.Remove( i );
   }
 
-  if(myWasLastMain && !myLastinMain.IsNull())
+  if(myWasLastMain && !myLastinMain.IsNull()) {
     if(myLastinMain == anIObj)
       myLastinMain.Nullify();
-  else 
+  } else
     if(!myWasLastMain && !myLastinColl.IsNull())
       if(myLastinColl == anIObj)
         myLastinColl.Nullify();
diff --git a/src/AIS2D/AIS2D_InteractiveContext.cxx b/src/AIS2D/AIS2D_InteractiveContext.cxx
index f8bd6a7..4ebe2a4 100644
--- a/src/AIS2D/AIS2D_InteractiveContext.cxx
+++ b/src/AIS2D/AIS2D_InteractiveContext.cxx
@@ -350,9 +350,9 @@ void AIS2D_InteractiveContext::EraseMode(
 
   if ( !myObjects.IsBound( anIObj ) ) return;
   
-  if ( anIObj->HasDisplayMode() ) 
+  if ( anIObj->HasDisplayMode() ) {
     if ( anIObj->DisplayMode() == aMode ) return;
-  else if ( myDisplayMode == aMode) return;
+  } else if ( myDisplayMode == aMode) return;
   Handle(AIS2D_GlobalStatus) GStatus = myObjects( anIObj );
   if ( GStatus->GraphicStatus() != AIS2D_DS_Displayed ) return;
   if ( GStatus->IsDModeIn( aMode ) ) {}
diff --git a/src/Bnd/Bnd_Box2d.cxx b/src/Bnd/Bnd_Box2d.cxx
index fd33203..cbe6a02 100644
--- a/src/Bnd/Bnd_Box2d.cxx
+++ b/src/Bnd/Bnd_Box2d.cxx
@@ -204,13 +204,13 @@ void Bnd_Box2d::Add (const gp_Dir2d& D)
 {
   Standard_Real DX = D.X();
   Standard_Real DY = D.Y();
-  if (DX < 0)
+  if (DX < 0) {
     if (DX < - gp::Resolution()) OpenXmin();
-  else
+  } else
     if (DX >   gp::Resolution()) OpenXmax();
-  if (DY < 0)
+  if (DY < 0) {
     if (DY < - gp::Resolution()) OpenYmin();
-  else
+  } else
     if (DY >   gp::Resolution()) OpenYmax();
 }
 
diff --git a/src/IGESData/IGESData_GlobalSection.cxx b/src/IGESData/IGESData_GlobalSection.cxx
index b602480..a4219e0 100644
--- a/src/IGESData/IGESData_GlobalSection.cxx
+++ b/src/IGESData/IGESData_GlobalSection.cxx
@@ -126,7 +126,7 @@ void IGESData_GlobalSection::Init(const Handle(Interface_ParamSet)& params,
 
   // Sending of message : Incorrect number of parameters (following the IGES version)
   // Version less than 5.3 
-  if  (theIGESVersion < 11) 
+  if  (theIGESVersion < 11) {
     if ((nbp < 24) || (nbp > 25)) {
        // 24 or 25 parameters are expected (parameter 25 is not required)
       Message_Msg Msg39 ("XSTEP_39");
@@ -135,7 +135,7 @@ void IGESData_GlobalSection::Init(const Handle(Interface_ParamSet)& params,
       if (nbp < 24) ach->SendFail(Msg39);
       else          ach->SendWarning(Msg39);
     }
-
+  }
   // Version 5.3 
   else if ((nbp < 25) || (nbp > 26)) {
     // 25 or 26 parameters are expected (parameter 25 is not required)
diff --git a/src/ShapeAnalysis/ShapeAnalysis_CheckSmallFace.cxx b/src/ShapeAnalysis/ShapeAnalysis_CheckSmallFace.cxx
index bb84ee5..c0b3cda 100644
--- a/src/ShapeAnalysis/ShapeAnalysis_CheckSmallFace.cxx
+++ b/src/ShapeAnalysis/ShapeAnalysis_CheckSmallFace.cxx
@@ -582,8 +582,10 @@ static Standard_Boolean CheckPoles(const TColgp_Array2OfPnt& poles, Standard_Int
   Standard_Integer i0 = (uorv == 1 ? poles.LowerCol() : poles.LowerRow());
   Standard_Integer i1 = (uorv == 1 ? poles.UpperCol() : poles.UpperRow());
   for (Standard_Integer i = i0; i <= i1-1; i ++) {
-    if (uorv == 1) if(poles(rank,i).IsEqual(poles(rank, i+1), 1e-15)) return Standard_True;
-    else      if(poles(i,rank).IsEqual(poles(i+1,rank), 1e-15)) return Standard_True;
+    if (uorv == 1) {
+      if(poles(rank,i).IsEqual(poles(rank, i+1), 1e-15)) return Standard_True;
+    } else
+      if(poles(i,rank).IsEqual(poles(i+1,rank), 1e-15)) return Standard_True;
   }  
   return Standard_False;
 }
diff --git a/src/TPrsStd/TPrsStd_AISPresentation.cxx b/src/TPrsStd/TPrsStd_AISPresentation.cxx
index e449b12..0fc7ff9 100644
--- a/src/TPrsStd/TPrsStd_AISPresentation.cxx
+++ b/src/TPrsStd/TPrsStd_AISPresentation.cxx
@@ -1031,12 +1031,12 @@ void TPrsStd_AISPresentation::AISErase (const Standard_Boolean remove)
       }
     }
     else {
-     if( remove )
+     if( remove ) {
       if( !ownctx.IsNull() ) {
 	ownctx->Remove (myAIS,Standard_False);
 	myAIS->SetToUpdate();
       }
-     else 
+     } else
       if( !ownctx.IsNull() ) ownctx->Erase (myAIS,Standard_False); 
     }
   }